//
//  TLTLPlugInBase.h
//  Base class for TillyTilla plug-in
//
//  Created by Prospaquila Project on 09/07/07.
//  Copyright 2009 Prospaquila Project. All rights reserved.
//

#import <Cocoa/Cocoa.h>

extern NSString *PlugInEnableApplyButtonNotificationName;

@interface TLTLPlugInBase : NSObject {

	IBOutlet NSView *contentView;
	NSArray *topLevelObjects;
	id imageView;
}

- (id)initWithNibName:(NSString*)nibname;
- (void)setImageView:(id)view;


+ (id)sharedInstance;
- (NSView*)contentView;

- (id)imageFromSource:(id)src inRect:(NSRect*)rectPtr forIconSize:(int)size isPreview:(BOOL)flag originalRect:(NSRect*)org resultRect:(NSRect*)rrect;

- (void)resetAllParameters;
- (void)sourceChanged:(id)newSrc iconSize:(int)size;
- (void)removeTemporaryItems;

- (BOOL)usesCoreImage;
- (BOOL)usesCIImageAsSource;
- (BOOL)usesOriginalRect;
- (BOOL)usesOnlyOutputImage;

- (BOOL)keepOriginalRect;

- (BOOL)enableAllMenu;
- (BOOL)enableApplyButton;
- (BOOL)enableTransformedGeometryButton;

- (IBAction)valueChanged:(id)sender;



@end

@interface NSObject (TLTLPlugInBaseAddition)

- (void)drawingView:(id)view willDrawImage:(id)src inRect:(NSRect)rect forIconSize:(int)size isPreview:(BOOL)flag originalRect:(NSRect*)org;
- (void)drawingView:(id)view didDrawImage:(id)src inRect:(NSRect)rect forIconSize:(int)size isPreview:(BOOL)flag originalRect:(NSRect*)org;

@end